//#ifdef F_CPU
//#undef F_CPU
//#define F_CPU 1000000L
//#endif

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <util/delay.h>

#define CHARLIE_A 0
#define CHARLIE_B 1
#define CHARLIE_C 2
#define CHARLIE_D 3

volatile int numLoop = 1;
byte randomLed = 0;

void setup()
{
  DDRB &= ~(1 << PB4);  //PCINT4, where a button is attached (pulled up)
  PORTB |= (1 << PB4);  //Pull up using software
  cli();          //Deactivate Interrupts as long as I change Bits      
  //MCUCR |= 1<<ISC01;   // INT0 mode = FALLING
  GIMSK |= (1<<PCIE);                    // Enable Pin Change Interrupts
  PCMSK |= (1 << PB4);                   // Use PB4 as interrupt pin 
  sei();          //Activate Interrupts
}

void loop() 
{
    if(numLoop>3)
      numLoop = 1;
    //ledSeq(numLoop, 500); 
    switch(numLoop)
    {
    case (1):
       for (int i=8; i >= 1; i--)
          ledSeq(i,300);
     break;
    case (2):
       for(int i=1; i<=8; i++)
          ledSeq(i,150);
      break;

    case (3):
           for (int i = 0; i<=7; i++)
     {
        byte randomLed = random (1,7);  
        ledSeq(randomLed, 50);
     }
     break;
    }
}


ISR(PCINT0_vect)
{
  //Since the PCINTn triggers on both rising and falling edge let's just looks for rising edge
  //i.e. pin goes to 5v
//  byte pinState;
//  pinState = (PINB >> PB4)& 1; //PINB is the register to read the state of the pins
//  if (pinState <1) //look at the pin state on the pin PINB register- returns 1 if high
//    numLoop++;
static unsigned long last_interrupt_time = 0;
 unsigned long interrupt_time = millis();
 // If interrupts come faster than 200ms, assume it's a bounce and ignore
 if (interrupt_time - last_interrupt_time > 200)
 {
   numLoop++;
 }
 last_interrupt_time = interrupt_time;
}

void ledSeq(byte i, int timeOn) {
     switch(i) 
     {
      case 1:
    
        // LIGHT D1 
      //turn on LED L1
      pinMode(CHARLIE_A, INPUT);      //row 1
      digitalWrite(CHARLIE_A, LOW);
      pinMode(CHARLIE_B, OUTPUT);     //row 2
      digitalWrite(CHARLIE_B, LOW);  
      pinMode(CHARLIE_C, OUTPUT);     //row 3
      digitalWrite(CHARLIE_C, HIGH);
      pinMode(CHARLIE_D, INPUT);      //row 4
      digitalWrite(CHARLIE_D, LOW);
      delay(timeOn);
      break;

      case 2:

      // LIGHT D2 
      //turn on LED L2
      pinMode(CHARLIE_A, OUTPUT);     //row 1 
      digitalWrite(CHARLIE_A, LOW);
      pinMode(CHARLIE_B, OUTPUT);     //row 2
      digitalWrite(CHARLIE_B, HIGH);   
      pinMode(CHARLIE_C, INPUT);      //row 3
      digitalWrite(CHARLIE_C, LOW);
      pinMode(CHARLIE_D, INPUT);      //row 4
      digitalWrite(CHARLIE_D, LOW);
      delay(timeOn);
      break;
//
//      // LIGHT D3
     case 3:
      pinMode(CHARLIE_A, OUTPUT);     //row 1
      digitalWrite(CHARLIE_A, HIGH);
      pinMode(CHARLIE_B, OUTPUT);     //row 2
      digitalWrite(CHARLIE_B, LOW);  
      pinMode(CHARLIE_C, INPUT);      //row 3
      digitalWrite(CHARLIE_C, LOW);
      pinMode(CHARLIE_D, INPUT);      //row 4
      digitalWrite(CHARLIE_D, LOW);
      delay(timeOn);
      break;

     
//    // LIGHT D4 
    case 4:
    pinMode(CHARLIE_A, INPUT);        //row 1
    digitalWrite(CHARLIE_A, LOW);
    pinMode(CHARLIE_B, OUTPUT);       //row 2
    digitalWrite(CHARLIE_B, HIGH);  
    pinMode(CHARLIE_C, OUTPUT);       //row 3
    digitalWrite(CHARLIE_C, LOW);
    pinMode(CHARLIE_D, INPUT);        //row 4
    digitalWrite(CHARLIE_D, LOW);
     delay(timeOn);
     break;
//    
//
//    // LIGHT D5 
    case 5:
    pinMode(CHARLIE_A, OUTPUT);       //row 1
    digitalWrite(CHARLIE_A, LOW);
    pinMode(CHARLIE_B, INPUT);        //row 2
    digitalWrite(CHARLIE_B, LOW);
    pinMode(CHARLIE_C, OUTPUT);       //row 3
    digitalWrite(CHARLIE_C, HIGH);
    pinMode(CHARLIE_D, INPUT);        //row 4
    digitalWrite(CHARLIE_D, LOW);
    delay(timeOn);
    break;
//
//    // LIGHT D6 
    case 6:
    pinMode(CHARLIE_A, OUTPUT);
    digitalWrite(CHARLIE_A, HIGH);
    pinMode(CHARLIE_B, INPUT);
    digitalWrite(CHARLIE_B, LOW);
    pinMode(CHARLIE_C, OUTPUT);
    digitalWrite(CHARLIE_C, LOW);
    pinMode(CHARLIE_D, INPUT);       //row 3
    digitalWrite(CHARLIE_D, LOW);
     delay(timeOn);
     break;
//
//    // LIGHT D7 
    case 7:
    pinMode(CHARLIE_A, INPUT);
    digitalWrite(CHARLIE_A, LOW);
    pinMode(CHARLIE_B, INPUT);
    digitalWrite(CHARLIE_B, LOW);
    pinMode(CHARLIE_C, OUTPUT);
    digitalWrite(CHARLIE_C, LOW);
    pinMode(CHARLIE_D, OUTPUT);       //row 3
    digitalWrite(CHARLIE_D, HIGH);
    delay(timeOn);
    break;
//
//    
//    // LIGHT D8 
    case 8:
    pinMode(CHARLIE_A, INPUT);
    digitalWrite(CHARLIE_A, LOW);
    pinMode(CHARLIE_B, INPUT);
    digitalWrite(CHARLIE_B, LOW);
    pinMode(CHARLIE_C, OUTPUT);
    digitalWrite(CHARLIE_C, HIGH);
    pinMode(CHARLIE_D, OUTPUT);    //row 3
    digitalWrite(CHARLIE_D, LOW);
    delay(timeOn);
    break;
 }
}
